
'=============================================================================
' 437-RTF                           1.002                          10/13/2016
'=============================================================================
' Programme to Change Files of the ASCII Code Page 437 into the
'  Rich Text Format (RTF) to Enable Printing of the File also under Windows.
'=============================================================================
' Handling:
' 12/27/2007 - 10/13/2016 Norbert Suedland
'=============================================================================
DIM Source$
DIM IntermediateDestination$
DIM Destination$
DIM Position%
DIM InputFile%
DIM OutputFile%
DIM Line$
DIM Counter%
DIM Copy$
DIM Character$
DIM Code$

IF ENVIRON$("FIRST") = "" THEN
  PRINT "Please start the programme "; CHR$(34); "437-RTF.BAT"; CHR$(34);
  PRINT " with the corresponding arguments."
ELSE
  Source$ = ENVIRON$("FIRST")
  IntermediateDestination$ = ENVIRON$("SECOND")
  IF IntermediateDestination$ = "" THEN
    IntermediateDestination$ = "437-RTF.ERG"
  END IF
  Destination$ = ENVIRON$("THIRD")
  IF Destination$ = "" THEN
    Destination$ = IntermediateDestination$
  END IF
  IF Source$ = IntermediateDestination$ THEN
    PRINT "Source "; CHR$(34); Source$; CHR$(34); " and intermediate";
    PRINT " destination "; CHR$(34); IntermediateDestination$; CHR$(34);
    PRINT " are identical."
    PRINT "The programme is terminated."
  ELSEIF Source$ = Destination$ THEN
    PRINT "Source "; CHR$(34); Source$; CHR$(34); " and destination ";
    PRINT CHR$(34); Destination$; CHR$(34); " are identical."
    PRINT "The programme is terminated."
  ELSE
    Position% = INSTR(Destination$, "\")
    WHILE Position% > 0
      Destination$ = RIGHT$(Destination$, LEN(Destination$) - Position%)
      Position% = INSTR(Destination$, "\")
    WEND

    InputFile% = FREEFILE
    OPEN Source$ FOR INPUT AS #InputFile%
      OutputFile% = FREEFILE
      OPEN IntermediateDestination$ FOR OUTPUT AS #OutputFile%
        PRINT #OutputFile%, "{\rtf1\deff0{\fonttbl";
        PRINT #OutputFile%, "{\f0\fcharset0 Courier New;}";
        PRINT #OutputFile%, "{\f1\fcharset161\fprq1 Courier New Greek;}";
        PRINT #OutputFile%, "{\f2\fcharset204\fprq1 Courier New Cyr;}";
        PRINT #OutputFile%, "{\f3\fcharset0 Times New Roman;}";
        PRINT #OutputFile%, "{\f4\fcharset161\fprq1 Times New Roman";
        PRINT #OutputFile%, " Greek;}";
        PRINT #OutputFile%, "{\f5\fcharset204\fprq1 Times New Roman Cyr;}}"
        PRINT #OutputFile%, "\margl1134\margr1134\margt1417\margb1134"
        PRINT #OutputFile%, "\viewkind1\uc1"
        PRINT #OutputFile%, "{\headerl \f3 ";
        PRINT #OutputFile%, "\widctlpar\brdrb\brdrs\brdrw30\brsp20 ";
        PRINT #OutputFile%, "\tqc\tx5000\tqr\tx10000\adjustright";
        PRINT #OutputFile%, "{page }";
        PRINT #OutputFile%, "{\field{\*\fldinst{ PAGE }}}{ / }";
        PRINT #OutputFile%, "{\field{\*\fldinst{ NUMPAGES }}}"
        PRINT #OutputFile%, "{\tab \'a9 Norbert Suedland\tab }"
        PRINT #OutputFile%, "{\field{\*\fldinst{ FILENAME }}";
        PRINT #OutputFile%, "{\fldrslt{"; Destination$; "}}}";
        PRINT #OutputFile%, "{\par }}"
        PRINT #OutputFile%, "{\headerr \f3 ";
        PRINT #OutputFile%, "\widctlpar\brdrb\brdrs\brdrw30\brsp20 ";
        PRINT #OutputFile%, "\tqc\tx5000\tqr\tx10000\adjustright "
        PRINT #OutputFile%, "{\field{\*\fldinst{ FILENAME }}";
        PRINT #OutputFile%, "{\fldrslt{"; Destination$; "}}}";
        PRINT #OutputFile%, "{\tab \'a9 Norbert Suedland\tab }"
        PRINT #OutputFile%, "{page }";
        PRINT #OutputFile%, "{\field{\*\fldinst{ PAGE }}}{ / }";
        PRINT #OutputFile%, "{\field{\*\fldinst{ NUMPAGES }}}"
        PRINT #OutputFile%, "{\par }}"
        PRINT #OutputFile%, "{\footerl}"
        PRINT #OutputFile%, "{\footerr}"
        PRINT #OutputFile%, "\b\fs20"
        WHILE EOF(InputFile%) = 0
          Copy$ = "{\f0 "
          LINE INPUT #InputFile%, Line$
          FOR Counter% = 1 TO LEN(Line$)
            Character$ = MID$(Line$, Counter%, 1)
            Code$ = ""
            SELECT CASE ASC(Character$)
            CASE 0
              STOP      'programming mistake?    '\x00
              Code$ = ""
            CASE 1
              Code$ = "\u9786\'3f"         '\x01
            CASE 2
              Code$ = "\u9787\'3f"         '\x02
            CASE 3
              Code$ = "\u9829\'3f"         '\x03
            CASE 4
              Code$ = "\u9830\'3f"         '\x04
            CASE 5
              Code$ = "\u9827\'3f"         '\x05
            CASE 6
              Code$ = "\u9824\'3f"         '\x06
            CASE 7
              Code$ = "\u9679\'3f"         '\x07
            CASE 8
              Code$ = "\u9688\'3f"         '\x08
            CASE 9
              Code$ = "\u9675\'3f"         '\x09
            CASE 10
              Code$ = "\u9689\'3f"         '\x0A
            CASE 11
              Code$ = "\u9794\'3f"         '\x0B
            CASE 12
              Code$ = "\u9792\'3f"         '\x0C
            CASE 13
              Code$ = "\u9834\'3f"         '\x0D
            CASE 14
              Code$ = "\u9835\'3f"         '\x0E
            CASE 15
              Code$ = "\u9788\'a4"         '\x0F
            CASE 16
              Code$ = "\u9658\'3f"         '\x10
            CASE 17
              Code$ = "\u9668\'3f"         '\x11
            CASE 18
              Code$ = "\u8597\'3f"         '\x12
            CASE 19
              Code$ = "\u8252\'3f"         '\x13
            CASE 20
              Code$ = "\'b6"               '\x14
            CASE 21
              Code$ = "\'a7"               '\x15
            CASE 22
              Code$ = "\u9644\'3f"         '\x16
            CASE 23
              Code$ = "\u8616\'3f"         '\x17
            CASE 24
              Code$ = "\u8578\'2b"         '\x18
            CASE 25
              Code$ = "\u8595\'3f"         '\x19
            CASE 26
              Code$ = "\u8594\'3f"         '\x1A
            CASE 27
              Code$ = "\u8592\'3f"         '\x1B
            CASE 28
              Code$ = "\u8735\'3f"         '\x1C
            CASE 29
              Code$ = "\u9612\'3f"         '\x1D
            CASE 30
              Code$ = "\u9650\'3f"         '\x1E
            CASE 31
              Code$ = "\u9660\'3f"         '\X1F
            CASE 34
              Code$ = "\u8243\'3f"         '"
            CASE 92
              Code$ = "\\"                 '\
            CASE 123
              Code$ = "\{"                 '{
            CASE 125
              Code$ = "\}"                 '}
            CASE 126
              Code$ = "\'98"               '~
            CASE 127
              Code$ = "\u8962\'a6"         '\x7F
            CASE 128
              Code$ = "\'c7"               '
            CASE 129
              Code$ = "\'fc"               '
            CASE 130
              Code$ = "\'e9"               '
            CASE 131
              Code$ = "\'e2"               '
            CASE 132
              Code$ = "\'e4"               '
            CASE 133
              Code$ = "\'e0"               '
            CASE 134
              Code$ = "\'e5"               '
            CASE 135
              Code$ = "\'e7"               '
            CASE 136
              Code$ = "\'ea"               '
            CASE 137
              Code$ = "\'eb"               '
            CASE 138
              Code$ = "\'e8"               '
            CASE 139
              Code$ = "\'ef"               '
            CASE 140
              Code$ = "\'ee"               '
            CASE 141
              Code$ = "\'ec"               '
            CASE 142
              Code$ = "\'c4"               '
            CASE 143
              Code$ = "\'c5"               '
            CASE 144
              Code$ = "\'c9"               '
            CASE 145
              Code$ = "\'e6"               '
            CASE 146
              Code$ = "\'c6"               '
            CASE 147
              Code$ = "\'f4"               '
            CASE 148
              Code$ = "\'f6"               '
            CASE 149
              Code$ = "\'f2"               '
            CASE 150
              Code$ = "\'fb"               '
            CASE 151
              Code$ = "\'f9"               '
            CASE 152
              Code$ = "\'ff"               '
            CASE 153
              Code$ = "\'d6"               '
            CASE 154
              Code$ = "\'dc"               '
            CASE 155
              Code$ = "\'a2"               '
            CASE 156
              Code$ = "\'a3"               '
            CASE 157
              Code$ = "\'a5"               '
            CASE 158
              Code$ = "\u8359\'50"         '
            CASE 159
              Code$ = "\'83"               '
            CASE 160
              Code$ = "\'e1"               '
            CASE 161
              Code$ = "\'ed"               '
            CASE 162
              Code$ = "\'f3"               '
            CASE 163
              Code$ = "\'fa"               '
            CASE 164
              Code$ = "\'f1"               '
            CASE 165
              Code$ = "\'d1"               '
            CASE 166
              Code$ = "\'aa"               '
            CASE 167
              Code$ = "\'ba"               '
            CASE 168
              Code$ = "\'bf"               '
            CASE 169
              Code$ = "\u8976\'ac"         '
            CASE 170
              Code$ = "\'ac"               '
            CASE 171
              Code$ = "\'bd"               '
            CASE 172
              Code$ = "\'bc"               '
            CASE 173
              Code$ = "\'a1"               '
            CASE 174
              Code$ = "\'ab"               '
            CASE 175
              Code$ = "\'bb"               '
            CASE 176
              Code$ = "\u9617\'a6"         '
            CASE 177
              Code$ = "\u9618\'a6"         '
            CASE 178
              Code$ = "\u9619\'a6"         '
            CASE 179
              Code$ = "\u9474\'a6"         '
            CASE 180
              Code$ = "\u9508\'a6"         '
            CASE 181
              Code$ = "\u9569\'a6"         '
            CASE 182
              Code$ = "\u9570\'a6"         '
            CASE 183
              Code$ = "\u9558\'2b"         '
            CASE 184
              Code$ = "\u9557\'2b"         '
            CASE 185
              Code$ = "\u9571\'a6"         '
            CASE 186
              Code$ = "\u9553\'a6"         '
            CASE 187
              Code$ = "\u9559\'2b"         '
            CASE 188
              Code$ = "\u9565\'2b"         '
            CASE 189
              Code$ = "\u9564\'2b"         '
            CASE 190
              Code$ = "\u9563\'2b"         '
            CASE 191
              Code$ = "\u9488\'2b"         '
            CASE 192
              Code$ = "\u9492\'2b"         '
            CASE 193
              Code$ = "\u9524\'2d"         '
            CASE 194
              Code$ = "\u9516\'2d"         '
            CASE 195
              Code$ = "\u9500\'2b"         '
            CASE 196
              Code$ = "\u9472\'2d"         '
            CASE 197
              Code$ = "\u9532\'2b"         '
            CASE 198
              Code$ = "\u9566\'a6"         '
            CASE 199
              Code$ = "\u9567\'a6"         '
            CASE 200
              Code$ = "\u9562\'2b"         '
            CASE 201
              Code$ = "\u9556\'2b"         '
            CASE 202
              Code$ = "\u9577\'2d"         '
            CASE 203
              Code$ = "\u9574\'2d"         '
            CASE 204
              Code$ = "\u9568\'a6"         '
            CASE 205
              Code$ = "\u9552\'2d"         '
            CASE 206
              Code$ = "\u9580\'2b"         '
            CASE 207
              Code$ = "\u9575\'2d"         '
            CASE 208
              Code$ = "\u9576\'2d"         '
            CASE 209
              Code$ = "\u9572\'2d"         '
            CASE 210
              Code$ = "\u9573\'2d"         '
            CASE 211
              Code$ = "\u9561\'2b"         '
            CASE 212
              Code$ = "\u9560\'2b"         '
            CASE 213
              Code$ = "\u9554\'2b"         '
            CASE 214
              Code$ = "\u9555\'2b"         '
            CASE 215
              Code$ = "\u9579\'2b"         '
            CASE 216
              Code$ = "\u9578\'2b"         '
            CASE 217
              Code$ = "\u9496\'2b"         '
            CASE 218
              Code$ = "\u9484\'2b"         '
            CASE 219
              Code$ = "\u9608\'a6"         '
            CASE 220
              Code$ = "\u9604\'5f"         '
            CASE 221
              Code$ = "\u9612\'a6"         '
            CASE 222
              Code$ = "\u9616\'a6"         '
            CASE 223
              Code$ = "\u9600\'af"         '
            CASE 224
              Code$ = "}{\f1 \'e1}{\f0 "   '
            CASE 225
              Code$ = "\'df"               '
            CASE 226
              Code$ = "}{\f1 \'c3}{\f0 "   '
            CASE 227
              Code$ = "}{\f1 \'f0}{\f0 "   '
            CASE 228
              Code$ = "}{\f1 \'d3}{\f0 "   '
            CASE 229
              Code$ = "}{\f1 \'f3}{\f0 "   '
            CASE 230
              Code$ = "\'b5"               '
            CASE 231
              Code$ = "}{\f1 \'f4}{\f0 "   '
            CASE 232
              Code$ = "}{\f1 \'d6}{\f0 "   '
            CASE 233
              Code$ = "}{\f1 \'c8}{\f0 "   '
            CASE 234
              Code$ = "}{\f1 \'d9}{\f0 "   '
            CASE 235
              Code$ = "}{\f1 \'e4}{\f0 "   '
            CASE 236
              Code$ = "\u8734\'38"         '
            CASE 237
              Code$ = "\'f8"               '
            CASE 238
              Code$ = "}{\f2 \'aa}{\f0 "   '
            CASE 239
              Code$ = "\u8745\'6e"         '
            CASE 240
              Code$ = "\u8801\'3d"         '
            CASE 241
              Code$ = "\'b1"               '
            CASE 242
              Code$ = "\u8805\'3d"         '
            CASE 243
              Code$ = "\u8804\'3d"         '
            CASE 244
              Code$ = "\u8992\'28"         '
            CASE 245
              Code$ = "\u8993\'29"         '
            CASE 246
              Code$ = "\'f7"               '
            CASE 247
              Code$ = "\u8776\'98"         '
            CASE 248
              Code$ = "\'b0"               '
            CASE 249
              Code$ = "\bullet "           '
            CASE 250
              Code$ = "\u8729\'b7"         '
            CASE 251
              Code$ = "\u8730\'76"         '
            CASE 252
              Code$ = "\u8319\'6e"         '
            CASE 253
              Code$ = "\'b2"               '
            CASE 254
              Code$ = "\u9642\'3f"         '
            CASE 255
              Code$ = SPACE$(1)            '\xFF
            CASE ELSE
              Code$ = Character$
            END SELECT
            Copy$ = Copy$ + Code$
          NEXT Counter%
          Copy$ = Copy$ + "}\par"
          PRINT #OutputFile%, Copy$
        WEND
        PRINT #OutputFile%, "}"
      CLOSE #OutputFile%
    CLOSE #InputFile%
    PRINT "The file "; CHR$(34); IntermediateDestination$; CHR$(34);
    PRINT " has been generated."
  END IF
END IF
SYSTEM


'=============================================================================
' End of "437-RTF.BAS"
'=============================================================================

